<?php

namespace Drupal\jsonapi_include\Normalizer;

use Drupal\jsonapi\Normalizer\JsonApiDocumentTopLevelNormalizer as JsonApiDocumentTopLevelNormalizerBase;

/**
 * @see \Drupal\jsonapi\Resource\JsonApiDocumentTopLevel
 */
class JsonApiDocumentTopLevelNormalizer extends JsonApiDocumentTopLevelNormalizerBase {

  /**
   * {@inheritdoc}
   */
  public function normalize($object, $format = NULL, array $context = []) {
    $normalized = parent::normalize($object, $format, $context);
    if (!empty($normalized['included']) && !empty($normalized['data'])) {
      $included = [];
      foreach ($normalized['included'] as $item) {
        $included[$item['id']] = $item;
      }
      foreach ($normalized['data'] as &$item) {
        foreach ($item['relationships'] as &$relationship) {
          $id = $relationship['data']['id'];
          if (isset($included[$id])) {
            $relationship['data']['attributes'] = $included[$id]['attributes'];
          }
        }
      }
    }
    return $normalized;
  }
}
